#include "StdAfx.h"
#include "..\inc\HPCEInterface_file.h"

HPCEInterface_file::HPCEInterface_file(char * txnFile, char * txnLogFile)
{
	m_pFile = new CHPCETxnFile(txnFile,true);
	m_pTxnLog = new CHPCETxnFile(txnLogFile,true);
	m_pTxnLogFmt = new CHPTxnLogFormatter();
}

HPCEInterface_file::HPCEInterface_file(void)
{
	//	Default - not normally used
	m_pFile = new CHPCETxnFile("C:\\HPCETxn.txt",true);
	m_pTxnLog = new CHPCETxnFile("C:\\HPCETxnLog.txt",true);
	m_pTxnLogFmt = new CHPTxnLogFormatter();
}

HPCEInterface_file::~HPCEInterface_file(void)
{
	delete m_pFile;
	delete m_pTxnLog;
	delete m_pTxnLogFmt;
}

bool HPCEInterface_file::BrokerVolume( PBrokerVolumeTxnInput pTxnInput )
{
	if (m_pTxnLog->WriteString(m_pTxnLogFmt->GetLogOutput(pTxnInput))) 
		return m_pFile->WriteBrokerVolumeTxn(pTxnInput);
	else
		return false;
}

bool HPCEInterface_file::CustomerPosition( PCustomerPositionTxnInput pTxnInput )
{
	if (m_pTxnLog->WriteString(m_pTxnLogFmt->GetLogOutput(pTxnInput))) 
		return m_pFile->WriteCustomerPositionTxn(pTxnInput);
	else
		return false;
}
bool HPCEInterface_file::MarketWatch( PMarketWatchTxnInput pTxnInput )                                            
{
	if (m_pTxnLog->WriteString(m_pTxnLogFmt->GetLogOutput(pTxnInput))) 
		return m_pFile->WriteMarketWatchTxn(pTxnInput);
	else
		return false;
}
bool HPCEInterface_file::SecurityDetail( PSecurityDetailTxnInput pTxnInput )
{
	if (m_pTxnLog->WriteString(m_pTxnLogFmt->GetLogOutput(pTxnInput))) 
		return m_pFile->WriteSecurityDetailTxn(pTxnInput);
	else
		return false;
}
bool HPCEInterface_file::TradeLookup( PTradeLookupTxnInput pTxnInput )
{
	if (m_pTxnLog->WriteString(m_pTxnLogFmt->GetLogOutput(pTxnInput))) 
		return m_pFile->WriteTradeLookupTxn(pTxnInput);
	else
		return false;
}
bool HPCEInterface_file::TradeOrder( PTradeOrderTxnInput pTxnInput, INT32 iTradeType, bool bExecutorIsAccountOwner )
{
	if (m_pTxnLog->WriteString(m_pTxnLogFmt->GetLogOutput(pTxnInput))) 
		return m_pFile->WriteTradeOrderTxn(pTxnInput);
	else
		return false;
}
bool HPCEInterface_file::TradeStatus( PTradeStatusTxnInput pTxnInput )
{
	if (m_pTxnLog->WriteString(m_pTxnLogFmt->GetLogOutput(pTxnInput))) 
		return m_pFile->WriteTradeStatusTxn(pTxnInput);
	else
		return false;
}
bool HPCEInterface_file::TradeUpdate( PTradeUpdateTxnInput pTxnInput )
{
	if (m_pTxnLog->WriteString(m_pTxnLogFmt->GetLogOutput(pTxnInput))) 
		return m_pFile->WriteTradeUpdateTxn(pTxnInput);
	else
		return false;
}
