#include "StdAfx.h"
#include "../inc/HPCEInterface_mem.h"

using namespace HPZREF;
using namespace TPCE;

HPCEInterface_mem::HPCEInterface_mem(pTXPCETxn pTxn, CBaseLogger *pLogger)
	:  m_pTxn (pTxn)
	,  m_pLogger ( pLogger )

{
	m_pFormatter = new HPZREFTxnFormatter();
}


HPCEInterface_mem::~HPCEInterface_mem(void)
{
	if (m_pFormatter) delete m_pFormatter;
}

bool HPCEInterface_mem::BrokerVolume( PBrokerVolumeTxnInput pTxnInput )
{
	strcpy (m_pTxn->txnID, "BV");
	m_pFormatter->FormatBrokerVolumeTxn(pTxnInput, &(m_pTxn->TxnInput.FileBrokerVolumeTxnInput));

	return true;
}

bool HPCEInterface_mem::CustomerPosition( PCustomerPositionTxnInput pTxnInput )
{
	strcpy (m_pTxn->txnID, "CP");
	m_pFormatter->FormatCustomerPositionTxn(pTxnInput, &(m_pTxn->TxnInput.FileCustomerPositionTxnInput));

	return true;
}
bool HPCEInterface_mem::MarketWatch( PMarketWatchTxnInput pTxnInput )                                            
{
	strcpy (m_pTxn->txnID, "MW");
	m_pFormatter->FormatMarketWatchTxn(pTxnInput, &(m_pTxn->TxnInput.FileMarketWatchTxnInput));

	return true;
}
bool HPCEInterface_mem::SecurityDetail( PSecurityDetailTxnInput pTxnInput )
{
	strcpy (m_pTxn->txnID, "SD");
	m_pFormatter->FormatSecurityDetailTxn(pTxnInput, &(m_pTxn->TxnInput.FileSecurityDetailTxnInput));

	return true;
}
bool HPCEInterface_mem::TradeLookup( PTradeLookupTxnInput pTxnInput )
{
	strcpy (m_pTxn->txnID, "TL");
	m_pFormatter->FormatTradeLookupTxn(pTxnInput, &(m_pTxn->TxnInput.FileTradeLookupTxnInput));

	return true;
}
bool HPCEInterface_mem::TradeOrder( PTradeOrderTxnInput pTxnInput, INT32 iTradeType, bool bExecutorIsAccountOwner )
{
	strcpy (m_pTxn->txnID, "TO");
	m_pFormatter->FormatTradeOrderTxn(pTxnInput, &(m_pTxn->TxnInput.FileTradeOrderTxnInput));

	return true;
}
bool HPCEInterface_mem::TradeStatus( PTradeStatusTxnInput pTxnInput )
{
	strcpy (m_pTxn->txnID, "TS");
	m_pFormatter->FormatTradeStatusTxn(pTxnInput, &(m_pTxn->TxnInput.FileTradeStatusTxnInput));

	return true;
}
bool HPCEInterface_mem::TradeUpdate( PTradeUpdateTxnInput pTxnInput )
{
	strcpy (m_pTxn->txnID, "TU");
	m_pFormatter->FormatTradeUpdateTxn(pTxnInput, &(m_pTxn->TxnInput.FileTradeUpdateTxnInput));

	return true;
}
