#include "StdAfx.h"
#include "../inc/HPMEEInterface_Callback.h"



HPMEEInterface_Callback::HPMEEInterface_Callback(TxnCallback pCallback, CBaseLogger* pLogger)
		:  m_pLogger ( pLogger )
{
	this->m_pCallback = pCallback;
}

HPMEEInterface_Callback::~HPMEEInterface_Callback()
{
}


bool HPMEEInterface_Callback::TradeResult( PTradeResultTxnInput pTxn )
{
	//  Format an all-character version of the Trade Result and callback
	if (!m_pCallback) return false;
	
	memset(&m_XPTRTxn, 0x20, sizeof(m_XPTRTxn));
	sprintf(m_XPTRTxn.trade_id, TTrade_charfmt, pTxn->trade_id);
	sprintf(m_XPTRTxn.trade_price, double_charfmt, pTxn->trade_price);

//	char msg[250];
//	sprintf(msg, "%ld Before TR", GetCurrentThreadId());
//	m_pLogger->SendToLogger(msg);

	(m_pCallback)("TR", (void *) &m_XPTRTxn, sizeof(m_XPTRTxn));

//	sprintf(msg, "%ld After TR", GetCurrentThreadId());
//	m_pLogger->SendToLogger(msg);

	return true;
}

bool HPMEEInterface_Callback::MarketFeed( PMarketFeedTxnInput pTxn )
{
		//  Format an all-character version of the Market Feed and callback
	if (!m_pCallback) return false;

	memset(&m_XPMFTxn, 0x20, sizeof(m_XPMFTxn));

	sprintf(m_XPMFTxn.unique_symbols, INT32_charfmt, pTxn->unique_symbols);
	strcpy(m_XPMFTxn.StatusAndTradeType.status_submitted, pTxn->StatusAndTradeType.status_submitted);
	strcpy(m_XPMFTxn.StatusAndTradeType.type_limit_buy, pTxn->StatusAndTradeType.type_limit_buy);
	strcpy(m_XPMFTxn.StatusAndTradeType.type_limit_sell, pTxn->StatusAndTradeType.type_limit_sell);
	strcpy(m_XPMFTxn.StatusAndTradeType.type_stop_loss, pTxn->StatusAndTradeType.type_stop_loss);
				
	for (int idx = 0; idx < F_max_feed_len; idx++)
	{
		sprintf(m_XPMFTxn.Entries[idx].price_quote, double_charfmt, pTxn->Entries[idx].price_quote);
		sprintf(m_XPMFTxn.Entries[idx].trade_qty, INT32_charfmt, pTxn->Entries[idx].trade_qty);
		strcpy (m_XPMFTxn.Entries[idx].symbol, pTxn->Entries[idx].symbol);
	}

//	char msg[250];
//	sprintf(msg, "%ld Before MF", GetCurrentThreadId());
//	m_pLogger->SendToLogger(msg);

	(m_pCallback) ("MF", (void *) &m_XPMFTxn, sizeof(m_XPMFTxn));
	
//	sprintf(msg, "%ld After MF", GetCurrentThreadId());
//	m_pLogger->SendToLogger(msg);

	return true;
}
