#include "StdAfx.h"
#include "../inc/HPMEEInterface_mem.h"

using namespace HPZREF;
using namespace TPCE;

HPMEEInterface_mem::HPMEEInterface_mem(pTXPMEETxnSet pTxnSet, CBaseLogger* pLogger)
	:  m_pTxnSet (pTxnSet)
	,  m_pLogger ( pLogger )
{
	m_pFormatter = new HPZREFTxnFormatter();
}

HPMEEInterface_mem::~HPMEEInterface_mem()
{
	if (m_pFormatter) delete m_pFormatter;
}


bool HPMEEInterface_mem::TradeResult( PTradeResultTxnInput pTxnInput )
{
	if (m_pTxnSet->trCount < MEETXNSET_TRMAX)
	{
	    m_pFormatter->FormatTradeResultTxn(pTxnInput, &(m_pTxnSet->MEETradeResultTxnInput[m_pTxnSet->trCount]));
		strcpy(m_pTxnSet->txnID[m_pTxnSet->trCount + m_pTxnSet->mfCount], "TR");
		m_pTxnSet->txnSubscript[m_pTxnSet->trCount + m_pTxnSet->mfCount] = m_pTxnSet->trCount;
	}

	m_pTxnSet->trCount++;
	
	return true;
}

bool HPMEEInterface_mem::MarketFeed( PMarketFeedTxnInput pTxnInput )
{
	if (m_pTxnSet->mfCount < MEETXNSET_MFMAX)
	{
	    m_pFormatter->FormatMarketFeedTxn(pTxnInput, &(m_pTxnSet->MEEMarketFeedTxnInput[m_pTxnSet->mfCount]));
		strcpy(m_pTxnSet->txnID[m_pTxnSet->trCount + m_pTxnSet->mfCount], "MF");
		m_pTxnSet->txnSubscript[m_pTxnSet->trCount + m_pTxnSet->mfCount] = m_pTxnSet->mfCount;
	}
	m_pTxnSet->mfCount++;

	return true;
}
