#include "Stdafx.h"
#include "HPMEE.h"

using namespace HPZREF;
using namespace TPCE;
using namespace std;

HPMEE::HPMEE()
	: m_TRCount(0)
{
}

HPMEE::~HPMEE(void)
{
	if (m_pMEE) delete m_pMEE;
	if (m_pInt) delete m_pInt;
	if (m_pLogger) delete m_pLogger;
}

//	Initialize with a structure pointer to return transaction array
bool HPMEE::Initialize(char * pLogFile, char * pInFileName,
			int iConfiguredCustomerCount, int iActiveCustomerCount,		
   		    UINT uniqueID, pTXPMEETxnSet pTxnSet)

{
	m_pLogger = new CEGenLogger(eDriverMEE, uniqueID, pLogFile, &m_fmt);

//	m_inputFiles.Initialize(eDriverMEE, iConfiguredCustomerCount, iActiveCustomerCount, pInFileName);

	m_pInt = new  HPMEEInterface_mem(pTxnSet, m_pLogger);
	
	m_pMEE = new CMEE(0, m_pInt, m_pLogger, m_inputFiles, uniqueID);

	return true;
}

//	Initialize with a function callback address to pass transactions
bool HPMEE::Initialize(char * pLogFile, char * pInFileName,
			int iConfiguredCustomerCount, int iActiveCustomerCount,		
   		    UINT uniqueID, TxnCallback pCallback)
{
	m_pLogger = new CEGenLogger(eDriverMEE, uniqueID, pLogFile, &m_fmt);

//	m_inputFiles.Initialize(eDriverMEE, iConfiguredCustomerCount, iActiveCustomerCount, pInFileName);

	m_pInt = new  HPMEEInterface_Callback(pCallback, m_pLogger);
	
	m_pMEE = new CMEE(0, m_pInt, m_pLogger, m_inputFiles, uniqueID);

	char msg[250];
	sprintf(msg, "%ld Initialized - handle %ld ", GetCurrentThreadId(), (long) this);
	m_pLogger->SendToLogger(msg);

	return true;
}


bool HPMEE::Shutdown()
{
	char msg[250];
	sprintf(msg, "%ld Shutdown", (long) this);
	m_pLogger->SendToLogger(msg);
	
	return true;
}

bool HPMEE::SubmitTradeRequest(TXPTradeRequest * pReq)
{
	m_TRCount++;
	char msg[250];
	sprintf(msg, "%ld SubmitTradeRequest %ld", GetCurrentThreadId(), m_TRCount);
	m_pLogger->SendToLogger(msg);

	TTradeRequest ttr;
	try
	{
		ttr.price_quote = strtod(pReq->price_quote, NULL);
		ttr.trade_id = _strtoi64(pReq->trade_id, NULL, 10);	
		ttr.trade_qty = strtol(pReq->trade_qty, NULL, 10);
		ttr.eAction = (TPCE::eMEETradeRequestAction)  strtol(pReq->eAction, NULL, 10);
		strcpy(ttr.symbol, pReq->symbol);
		strcpy(ttr.trade_type_id, pReq->trade_type_id);
	}
	catch(...)
	{
		m_pLogger->SendToLogger("EXCEPTION ON ALLOCATED DATA");
		throw;
	}

	try
	{
	m_pMEE->SubmitTradeRequest(&ttr);
	}
	catch(...)
	{
		m_pLogger->SendToLogger("EXCEPTION ON EGEN CODE");
		throw;
	}

	//	TODO: what is the return?
	return true;
}

bool HPMEE::EnableTickerTape(void)
{
	return true;
}

bool HPMEE::DisableTickerTape(void)
{
	return true;
}

