// HPMSMQ.cpp : Defines the exported functions for the DLL application.
//

#include "stdafx.h"

extern "C" __declspec(dllexport) int __cdecl InitializeForReceive(char * pComputerName, char * pQueueName, 
	void * pMsg, int MsgMaxSize, char * pLabel, int MaxLabelLength)
{
	CMSMQReceiver * pHandler = new CMSMQReceiver();
	HRESULT hr = pHandler->Initialize(pComputerName, pQueueName, pMsg, MsgMaxSize, pLabel, MaxLabelLength);
	
	if (FAILED(hr)) 
	{	
		return (int) hr; 
	}
	else 
	{
		return PtrToInt(pHandler);
	}

}

extern "C" __declspec(dllexport) int __cdecl InitializeForSend(char * pComputerName, char * pQueueName)
{
	CMSMQSender * pHandler = new CMSMQSender();
	HRESULT hr = pHandler->Initialize(pComputerName, pQueueName);
	
	if (FAILED(hr)) 
	{	
		return (int) hr; 
	}
	else 
	{
		return PtrToInt(pHandler);
	}
	
}


extern "C" __declspec(dllexport) int __cdecl SendMsg(int handle, void * pMsg, int MsgSize, char * pLabel)
{
	if (handle <= 0) return E_HANDLE;

	CMSMQSender * pHandler = static_cast<CMSMQSender *>(IntToPtr(handle));

	HRESULT hr = pHandler->Send(pMsg, MsgSize, pLabel);
	return (int) hr;
}


extern "C" __declspec(dllexport) int __cdecl ReceiveMsg(int handle, unsigned int timeout)
{
	if (handle <= 0) return E_HANDLE;

	CMSMQReceiver * pHandler = static_cast<CMSMQReceiver *>(IntToPtr(handle));

	HRESULT hr = pHandler->Receive(timeout);
	
	return (int) hr;
}


extern "C" __declspec(dllexport) int __cdecl ShutdownSender (int handle)
{
	if (handle <= 0) return E_HANDLE;

	CMSMQSender * pHandler = static_cast<CMSMQSender *>(IntToPtr(handle));
	HRESULT hr = pHandler->Shutdown();

	delete pHandler;

	return (int) hr;

}


extern "C" __declspec(dllexport) int __cdecl ShutdownReceiver (int handle)
{
	if (handle <= 0) return E_HANDLE;

	CMSMQReceiver * pHandler = static_cast<CMSMQReceiver *>(IntToPtr(handle));
	wprintf(L"ShutdownReceiver Thread Id: %x.\n", GetCurrentThreadId());

	HRESULT hr = pHandler->Shutdown();

	delete pHandler;

	return (int) hr;
}

