#pragma once

#include "stdafx.h"

class CMSMQReceiver
{
private:
	//	MSMQ related
	HANDLE m_hQueue;	

	//	Receive msg props
	MQMSGPROPS * m_pMsgProps;

	static const int R_NUMBEROFPROPERTIES = 4;
	static const DWORD R_ARRAY_PROP_LABEL_LEN = 0;
	static const DWORD R_ARRAY_PROP_LABEL     = 1;
	static const DWORD R_ARRAY_PROP_BODY_SIZE = 2;
	static const DWORD R_ARRAY_PROP_BODY      = 3;

	static bool m_errorStatus;

	//	Buffers for body and label - from caller
	void * m_pMsg;
	char * m_pLabel;	//	Caller's ASCII version
	int m_MaxLabelLength;
	int m_MaxMsgSize;

	LPWSTR m_pLabelMSMQ;		//	MSMQ Wide Char version

	CMSMQReceiver(const CMSMQReceiver&);	// prevent copying
	CMSMQReceiver& operator=(const CMSMQReceiver&);

public:
	CMSMQReceiver(void);
	~CMSMQReceiver(void);

	HRESULT Initialize(char * pComputerName, char * pQueueName, 
			void * pMsg, int MaxMsgSize, char * pLabel, int MaxLabelLength);
	HRESULT Receive(DWORD timeout);
	HRESULT Shutdown(void);
};

