#pragma once

#include "../../TPC-E/inc/cesutinterface.h"
#include "../inc/HPZREFXPTxnStructs.h"
#include "../inc/HPZREFTxnFormatter.h"

using namespace TPCE;

namespace HPZREF
{
class HPCEInterface_mem :
	public CCESUTInterface
{
private:
	pTXPCETxn m_pTxn;
	
	HPZREFTxnFormatter * m_pFormatter;

    CBaseLogger*                m_pLogger;


public:
	HPCEInterface_mem(pTXPCETxn pTxn, CBaseLogger* pLogger);
	~HPCEInterface_mem(void);

	virtual bool BrokerVolume( PBrokerVolumeTxnInput pTxnInput );                                               
    virtual bool CustomerPosition( PCustomerPositionTxnInput pTxnInput );                                       
    virtual bool MarketWatch( PMarketWatchTxnInput pTxnInput );                                                 
    virtual bool SecurityDetail( PSecurityDetailTxnInput pTxnInput );
    virtual bool TradeLookup( PTradeLookupTxnInput pTxnInput );
    virtual bool TradeOrder( PTradeOrderTxnInput pTxnInput, INT32 iTradeType, bool bExecutorIsAccountOwner );
    virtual bool TradeStatus( PTradeStatusTxnInput pTxnInput );
    virtual bool TradeUpdate( PTradeUpdateTxnInput pTxnInput );

};

}   // namespace HPZREF